=== debian/changelog ===
lammps (0~20150313.gitfa668e1-1) unstable; urgency=medium

  * Upload into unstable.

 -- Anton Gladky <gladk@debian.org>  Wed, 29 Apr 2015 23:44:49 +0200

lammps (0~20150313.gitfa668e1-1~exp1) experimental; urgency=medium

  * [aad2273] Imported Upstream version 0~20150313.gitfa668e1
  * [820b5c5] Refresh patches. Remove applied by upstream.
  * [b303847] Update d/copyright.
  * [5dc10e0] Minor fix in d/rules.
  * [b833c3c] Set Standards-Version: 3.9.6. No changes.
  * [0e947fe] Enable C++11.

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Mar 2015 20:59:57 +0100
