## lammps 0~20151117.gite3c4db7

=== src/Makefile ===
--- 
+++ 
@@ -41,17 +41,19 @@
 
 # Package variables
 
-PACKAGE = asphere body class2 colloid coreshell dipole fld gpu granular kim \
+PACKAGE = asphere body class2 colloid compress coreshell dipole fld gpu \
+	  granular kim \
 	  kokkos kspace manybody mc meam misc molecule mpiio opt peri poems \
-	  qeq reax replica rigid shock snap srd voronoi xtc
-
-PACKUSER = user-atc user-awpmd user-cg-cmm user-colvars \
-	   user-cuda user-eff user-fep user-intel user-lb user-misc \
-	   user-molfile user-omp user-phonon user-qmmm user-quip \
-	   user-reaxc user-sph
-
-PACKLIB = gpu kim kokkos meam poems reax voronoi \
-	  user-atc user-awpmd user-colvars user-cuda user-molfile \
+	  python qeq reax replica rigid shock snap srd voronoi xtc
+
+PACKUSER = user-atc user-awpmd user-cg-cmm user-colvars user-cuda \
+	   user-diffraction user-drude user-eff user-fep user-h5md \
+	   user-intel user-lb user-mgpt \
+	   user-misc user-molfile user-omp user-phonon user-qmmm user-qtb \
+	   user-quip user-reaxc user-smd user-smtbq user-sph user-tally
+
+PACKLIB = compress gpu kim kokkos meam poems python reax voronoi \
+	  user-atc user-awpmd user-colvars user-cuda user-h5md user-molfile \
 	  user-qmmm user-quip 
 
 PACKALL = $(PACKAGE) $(PACKUSER)
