=== debian/changelog ===
lammps (0~20151117.gite3c4db7-3) unstable; urgency=medium

  * [579bfa9] Respect --parallel option. (Closes: #805533)
  * [24992fd] Remove duplicates in doc.
  * [acdfe10] Minor fix in d/copyright.

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Dec 2015 11:58:46 +0100

lammps (0~20151117.gite3c4db7-2) unstable; urgency=medium

  * [ce58358] Update get_orig script.
  * [7fe6df7] Remove embedded js-scripts.

 -- Anton Gladky <gladk@debian.org>  Wed, 18 Nov 2015 21:49:58 +0100

lammps (0~20151117.gite3c4db7-1) unstable; urgency=medium

  * [879c7b4] Add libeigen3-dev to BD.
  * [50e6397] Apply cme fix dpkg-control.
  * [14e7d41] Update patch.
  * [a00dbfc] Imported Upstream version 0~20151117.gite3c4db7
  * [8f8aa65] Update d/copyright.

 -- Anton Gladky <gladk@debian.org>  Wed, 18 Nov 2015 21:02:52 +0100
